#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import glob
import re

loaded = False
data = {}

def load( filename ):
	glob.info( "loading config " + filename )
	global data
	data[ "file" ] = filename

	file = open( filename )#TODO check if OK and make a better end than just backtrace
	config = file.readlines()
	file.close()

	found = False
	for ln in config:#cut off all before core section
		if ln.find( "[core]" ) != -1:
			glob.info( "Found core section " + ln )
			del( config[ :config.index( ln ) + 1 ] )
			found = True
			break
	if not found:
		glob.fatal( "No core section in config" )
	secRe = re.compile( "^\s*\[.+\]\s*$" )
	for ln in config:#cut off all after config section
		if secRe.match( ln ):
			glob.info( "Removing all following sections " + ln )
			del( config[ config.index( ln ): ] )
			break

	valRe = re.compile( "^\s*([^#. \t]*)\s*=\s*(.*\S)\s*$" )
	global port, source
	for ln in config:
		mo = valRe.match( ln )
		if mo:
			glob.info( "Executing config line " + ln )
			data[ mo.group( 1 ) ] = mo.group( 2 ).strip( '"' )

	global loaded
	loaded = True
